%2-7-2007 Raj Chetty
% This file calculates level of tau needed to finance a given b and then computes indirect utility J0(b)

%psi(s) = theta*[s^(1+sigma)]/(1+sigma)
%psi'(s)=theta*s^sigma
%u(c) = [c^(1-gamma)]/(1-gamma)
%v(c) = [c^(1-gamma)]/(1-gamma)
%delta=0
%r=0

function [D_star, D_comp_star, s_0_star, J_0_star, tau_bb, unconst_flag] = budget_balance(A0,L,G,G_T,w,a,b,tau_init,T,B,gridsize,toler,theta,sigma,gamma)

tau = tau_init;
[D_star, D_comp_star, s_0_star, J_0_star, rho_star, t1, t2, unconst_flag] = opt_search_polfn_crra(A0,L,G,G_T,w,a,b,tau,T,B,gridsize,theta,sigma,gamma);
budget_error_pct = abs(((T-D_star)*tau - b*D_comp_star)/w)

while budget_error_pct > toler
    tau = b*D_comp_star/(T-D_star);
    if w-tau<b
        disp('Note: Benefit Rate Exceeds Net-of-Tax Wage for t<=B')
    end
    [D_star, D_comp_star, s_0_star, J_0_star, rho_star, t1, t2, unconst_flag] = opt_search_polfn_crra(A0,L,G,G_T,w,a,b,tau,T,B,gridsize,theta,sigma,gamma);
    budget_error_pct = abs(((T-D_star)*tau - b*D_comp_star)/w)
end

tau_bb = tau;